#ifdef WIN32
#include <windows.h>
#define LOAD_LIB		LoadLibrary("SCreaderlib.dll")
#define CLOSE_LIB		FreeLibrary
#define DLL_HANDLE		HINSTANCE
#define GET_FCT			GetProcAddress
#else
#include <dlfcn.h>
#define LOAD_LIB		dlopen("libSCreader.so.1", RTLD_LAZY)
#define CLOSE_LIB(x)	dlclose(x)
#define DLL_HANDLE		void*
#define GET_FCT			dlsym
#endif

#include "reader.h"

static DLL_HANDLE hDll = NULL;

static char				szCharBuffer[ATR_BUF_SIZE];
static unsigned char	pbByteBuffer[ATR_BUF_SIZE];

/* Pointers of function of the SCreaderlib library */
typedef int		(*TInitReader)		(ReaderDesc *, rd_type, char *);
typedef void	(*TCloseReader)		(ReaderDesc *);
typedef int		(*TPowerDown)		(ReaderDesc *);
typedef int		(*TResetCardAscii)	(ReaderDesc *,char*,int);
typedef int		(*TSendIncomingAPDUAscii)
					(ReaderDesc *, const char *, char *, int);
typedef int		(*TSendOutgoingAPDUAscii)
					(ReaderDesc *, const char *, char *, int);
typedef int		(*TSendIncomingOutgoingAPDUAscii)
					(ReaderDesc *, const char *, char *, int);
typedef int		(*TGetRerrno)(void);
typedef char *	(*TGetRerrStr)(int);
typedef char *	(*TISO7816_ErrorStr)(int, int);

TInitReader		pInitReader = NULL;
TCloseReader	pCloseReader = NULL;
TPowerDown		pPowerDown = NULL;
TResetCardAscii	pResetCard = NULL;
TSendIncomingAPDUAscii pSendIncomingAPDU = NULL;
TSendOutgoingAPDUAscii pSendOutgoingAPDU = NULL;
TSendIncomingOutgoingAPDUAscii pSendIncomingOutgoingAPDU = NULL;
TGetRerrno	pGetRerrno = NULL;
TGetRerrStr	pGetRerrStr = NULL;
TISO7816_ErrorStr pISO7816_ErrorStr = NULL;

