#!/usr/bin/perl -w

#
#	get_challenge.pl - get random numbers from the card
#	Ludovic Rousseau
#	lun avr 24 21:15:36 CEST 2000
#	

use strict;
use cardreader;

my ($scr, $data, $sw, $length, $ret, $cmd);
my ($len);

$|=1;

######################   new    ####################
# allocate a descriptor
# the default device is /dev/screader and the default type is TLP
$scr = new cardreader or die "Can't allocate reader: $!\n";

######################   ResetCard   ####################
print "ATR: ", $scr -> ResetCard, "\n";

####################   SendIncomingAPDU  #################
# CLA = 0
# INS = B4 GET CHALLENGE
# P1 = 00
# P2 = 00
# Lc = 00
for $len (0..255)
{
	$scr -> ResetCard;
	$cmd = "00"."B4"."00"."00".(uc sprintf "%02x", $len);
	print "=>$cmd\n";
	$sw = $scr -> SendIncomingAPDU($cmd) or print "SendIncomingAPDU: $!\n";
	print "sw $sw, ", $scr -> ISO7816_ErrorStr($sw), "\n" if (! $sw =~ m/^$/);
}


###############   PowerDown  ################
$scr -> PowerDown or die "PowerDown: $!\n";

undef $scr;

