#!/usr/bin/perl -w

#
#	scan.pl - scan the root directory
#	Ludovic Rousseau
#	dim sep  3 16:58:29 CEST 2000
#	

use strict;
use cardreader;

my ($scr, $data, $sw, $cmd);
my ($i, $j, $b);

$|=1;

######################   new    ####################
# allocate a descriptor
# the default device is /dev/screader and the default type is TLP
$scr = new cardreader or die "Can't allocate reader: $!\n";

######################   ResetCard   ####################
print "ATR: ", $scr -> ResetCard, "\n";

####################   SendIncomingAPDU  #################
# CLA = 0
# INS = A4 SELECT FILE
# P1 = 01 Select child DF (data field=DF identifier)
# P1 = 03 Select parent DF of the current DF (empty data field)
# P2 = 00 First record
# Lc = 02 SFI (short file identifier) is on 2 bytes
# Data = 3F00
print "[0000]";
for $i (0..255)
{
	$b = "00"."A4"."01"."00"."02".(uc sprintf "%02x", $i);
	for $j (0..255)
	{
#		$scr -> ResetCard;
		print "\b\b\b\b\b\b[", (uc sprintf "%04x", $i*256+$j), "]";
		$cmd = $b.(uc sprintf "%02x", $j);
		$sw = $scr -> SendIncomingAPDU($cmd) or print "SendIncomingAPDU: $!\n";
		#print "sw $sw, ", $scr -> ISO7816_ErrorStr($sw), "\n";

		if ($sw =~ m/^61/)
		{
			# 61xy: xy bytes of response bytes still available

			print "\n=>$cmd\n";
			print "Found one directory: ", (uc sprintf "%04x", $i*256+$j), "\n";
			print "sw $sw, ", $scr -> ISO7816_ErrorStr($sw), "\n";

			# go up one level
			$cmd = "00"."A4"."03"."00"."00";
			print "=>$cmd\n";
			$sw = $scr -> SendIncomingAPDU($cmd) or print "SendIncomingAPDU: $!\n";
			print "sw $sw, ", $scr -> ISO7816_ErrorStr($sw), "\n";
			print "[0000]";
		}
		elsif ($sw ne "6A82")
		{
			# 6A82: Wrong parameter(s) P1-P2. File not found
			print "sw $sw, ", $scr -> ISO7816_ErrorStr($sw), "\n[0000]";
		}
	}
}

###############   PowerDown  ################
$scr -> PowerDown or die "PowerDown: $!\n";

undef $scr;

