#!/usr/bin/perl -w

#
#	simple.pl - very simple example
#	Ludovic Rousseau
#	$Id: simple.pl,v 1.3 2000/09/28 07:54:02 rousseau Exp $
#	$Log: simple.pl,v $
#	Revision 1.3  2000/09/28 07:54:02  rousseau
#	Added an SendOutgoingAPDU command
#	
#	

use strict;
use cardreader;

my ($scr, $sw, $cmd, $data);

######################   new    ####################
# allocate a descriptor
# the default device is /dev/screader
$scr = new cardreader or die "Can't allocate reader: $!\n";

######################   ResetCard   ####################
print "ATR: ", $scr -> ResetCard, "\n";

####################   SendIncomingAPDU  #################
# CLA = 0
# INS = A4 SELECT FILE
# P1 = 01
# P2 = 00
# Lc = 02
# Data = 0100
$cmd = "00"."A4"."01"."00"."02"."0100";
print "=>$cmd\n";
$sw = $scr -> SendIncomingAPDU($cmd) or print "SendIncomingAPDU: $!\n";
print "sw $sw, ", $scr -> ISO7816_ErrorStr($sw), "\n";

####################   SendOutgoingAPDU  #################
# CLA = 0
# INS = C0 GET RESPONSE
# P1 = 00
# P2 = 00
# Lc = depends
# Data = 
$cmd = "00"."C0"."00"."00".(substr $sw, 2);
print "=>$cmd\n";
($data, $sw) = $scr -> SendOutgoingAPDU($cmd) or print "SendOutgoingAPDU: $!\n";
print "sw $sw, ", $scr -> ISO7816_ErrorStr($sw), "\n";
print "Data $data\n";

###############   PowerDown  ################
$scr -> PowerDown or die "PowerDown: $!\n";

undef $scr;

