#!/usr/bin/perl -w

#
#	testreader.pl - Test the cardreader module using the LOW level
#	interface.
#
#	YOU SHOULD NOT USE THIS INTERFACE UNLESS YOU KNOW WHAT YOU ARE
#	DOING!!
#	

use strict;
use cardreader;

my ($device, $scr, $length, $str, $ret, $data, $sw);

print "*****************   BEGIN   *****************\n";

######################   InitSerial       ####################
print "InitSerial: ";
$device = "/dev/screader";
$device = "COM1" if ($^O eq "MSWin32");
$scr = cardreader::_InitReader(0, $device);
if ($scr < 0)
{
	print "\nError: $!\n";
}
else
{
	print "OK\n";
}

######################   ResetCard   ####################
print "ResetCard: ";
$str = cardreader::_ResetCard($scr);
if ($str eq "")
{
	print "Error: $!\n";
}
else
{
	print "$str\n";
}

####################   SendIncomingAPDU  #################
print "SendIncomingAPDU: ";
# CLA = 0
# INS = SELECT FILE
# P1 = 00
# P2 = 00
# Lc = 02
# Data = 3F00
$sw = cardreader::_SendIncomingAPDU($scr,"00A40000023F00");
if ($str eq "")
{
	print "Error: $!\n";
}
else
{
	print "\n\tStatus Words: $sw, " . cardreader::_ISO7816_ErrorStr($sw). "\n";
}

#get the length of data get
$length = substr $str, 2;

#################   SendOutgoingAPDU   ####################
print "SendOutgoingAPDU: ";
($data,$sw) = cardreader::_SendOutgoingAPDU($scr,"00C00000".$length);

print cardreader::_SendOutgoingAPDU($scr,"00C00000".$length);


if ($data eq "" && $sw eq "")
{
	print "Error: $!\n";
}
else
{
	print "\n\tResponse: $data\n";
	print "\tStatus Words: $sw, " . cardreader::_ISO7816_ErrorStr($sw). "\n";
}


###############   SendIncomingOutgoingAPDU #################
print "SendIncomingOutgoingAPDU: ";
($data,$sw) = cardreader::_SendIncomingOutgoingAPDU($scr,"00A40000023F00");
if ($data eq "" && $sw eq "")
{
	print "Error: $!\n";
}
else
{
	print "\n\tResponse: $data\n";
	print "\tStatus Words: $sw, " . cardreader::_ISO7816_ErrorStr($sw) . "\n";
	print "\n";
}


###############   PowerDown  ################
print "PowerDown: ";
$ret = cardreader::_PowerDown($scr);
if (!$ret)
{
	print "Error: $!\n";
}
else
{
	print "OK \n";
}

###############   CloseSerial  ################
print "CloseSerial: " ;
if(!cardreader::_CloseReader($scr))
{
	print "Erreur: $!\n";
}
else
{
	print "OK";
}
print "\n";


undef $scr;

print "*****************    END   *****************\n";

