#!/usr/bin/perl -w

#
#	testreader-obj.pl - Test the cardreader module
#	Ludovic Rousseau
# lun avr 24 00:24:03 CEST 2000
#	

use strict;
use cardreader;

my ($scr, $data, $sw, $length, $ret);

######################   new    ####################
# allocate a descriptor
# the default device is /dev/screader and the default type is TLP
$scr = new cardreader or die "Can't allocate reader: $!\n";

######################   ResetCard   ####################
print "ATR: ", $scr -> ResetCard, "\n";

####################   SendIncomingAPDU  #################
# CLA = 0
# INS = A4 SELECT FILE
# P1 = 00
# P2 = 00
# Lc = 02
# Data = 3F00
$sw = $scr -> SendIncomingAPDU("00A40000023F00");
if ($sw)
{
	print "SendIncomingAPDU: $sw ", $scr -> ISO7816_ErrorStr($sw), "\n";
}
else
{
	print "Error SendIncomingAPDU: $!\n";
}

#################   SendOutgoingAPDU   ####################
# CLA = 0
# INS = C0 GET RESPONSE
# P1 = 0
# P2 = 0
# Lc = ?

# length is th 2nd byte of SW
$length = substr $sw, 2;

($data, $sw) = $scr -> SendOutgoingAPDU("00C00000".$length);
if ($sw)
{
	print "SendOutgoingAPDU response: $data\n";
	print "SendOutgoingAPDU status word: $sw ",
		$scr -> ISO7816_ErrorStr($sw), "\n";
}
else
{
	print "Error SendOutgoingAPDU: $!\n";
}

###############   SendIncomingOutgoingAPDU #################
# CLA = 00
# INS = A4 SELECT FILE
# P1 = 00
# P2 = 00
# Lc = 2
# Data = 3F00
($data,$sw) = $scr -> SendIncomingOutgoingAPDU("00A40000023F00");

if ($sw)
{
	print "SendIncomingOutgoingAPDU response: $data\n";
	print "SendIncomingOutgoingAPDU status word: $sw ",
		$scr -> ISO7816_ErrorStr($sw), "\n";
}
else
{
	print "Error SendIncomingOutgoingAPDU: $!\n";
}

###############   PowerDown  ################
$scr -> PowerDown or die "PowerDown: $!\n";

###############   close the serial port  ################
undef $scr;

