# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

my ($scr,$def_device,$device,$reader_type,$tmp);

BEGIN { $| = 1; print "1..5\n"; }
END {print "not ok 1\n" unless $loaded;}

use cardreader;
$loaded = 1;
print "ok $loaded\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

# Get the device string
$def_device = "/dev/screader";
$def_device = "COM1" if ($^O eq "MSWin32");

print STDERR "\nEnter the device [" . $def_device . "]: ";
chomp($device = <STDIN>);
$device = $def_device if ($device eq "");

# Get the reader type
print STDERR "Enter the reader type (TLP,RFTLP) [TLP]: ";
chomp($tmp = <STDIN>);
$tmp = uc($tmp);
$reader_type = -1;
$reader_type = 0 if ($tmp eq "" or $tmp eq "TLP");
$reader_type = 1 if ($tmp eq "RFTLP");

$loaded = 2;
$scr = cardreader::_InitReader($reader_type, $device);
if ($scr < 0)
{
	print "not ";
	print STDERR "_InitReader $!\n";
}
print "ok 2\n";

$loaded = 3;
$ret = cardreader::_ResetCard($scr);
if ($ret eq "")
{
	print "not ";
	print STDERR "_ResetCard $!\n";
}
print "ok $loaded\n";

$loaded = 4;
$ret = cardreader::_PowerDown($scr);
if (!$ret)
{
	print "not ";
	print STDERR "_PowerDown $!\n";
}
print "ok $loaded\n";

$loaded = 5;
$ret = cardreader::_CloseReader($scr);
if (!$ret)
{
	print "not ";
	print STDERR "_CloseReader $!\n";
}
print "ok $loaded\n";

